{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "-m",
                "ochre.kb_tss_concat_files"
            ],
            "requirements": [
                {
                    "listing": "$(inputs.in_files)",
                    "class": "InitialWorkDirRequirement"
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(runtime.outdir)",
                    "position": 1
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#kb-tss-concat-files.cwl/in_files"
                }
            ],
            "id": "#kb-tss-concat-files.cwl",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.txt"
                    },
                    "id": "#kb-tss-concat-files.cwl/out_files"
                }
            ]
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "default": [
                        "SP"
                    ],
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "id": "#main/element"
                },
                {
                    "default": "alto.xml",
                    "type": "string",
                    "id": "#main/endswith"
                },
                {
                    "type": "Directory",
                    "id": "#main/in_dir"
                },
                {
                    "default": "alto",
                    "type": "string",
                    "id": "#main/in_fmt"
                },
                {
                    "default": "text",
                    "type": "string",
                    "id": "#main/out_fmt"
                },
                {
                    "default": true,
                    "type": "boolean",
                    "id": "#main/recursive"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/kb-tss-concat-files/out_files",
                    "id": "#main/text_files"
                }
            ],
            "steps": [
                {
                    "run": "#kb-tss-concat-files.cwl",
                    "in": [
                        {
                            "source": "#main/ocr-transform-1/out_file",
                            "id": "#main/kb-tss-concat-files/in_files"
                        }
                    ],
                    "out": [
                        "#main/kb-tss-concat-files/out_files"
                    ],
                    "id": "#main/kb-tss-concat-files"
                },
                {
                    "run": "#ls.cwl",
                    "in": [
                        {
                            "source": "#main/endswith",
                            "id": "#main/ls/endswith"
                        },
                        {
                            "source": "#main/in_dir",
                            "id": "#main/ls/in_dir"
                        },
                        {
                            "source": "#main/recursive",
                            "id": "#main/ls/recursive"
                        }
                    ],
                    "out": [
                        "#main/ls/out_files"
                    ],
                    "id": "#main/ls"
                },
                {
                    "run": "#ocr-transform.cwl",
                    "in": [
                        {
                            "source": "#main/remove-xml-elements-1/out_file",
                            "id": "#main/ocr-transform-1/in_file"
                        },
                        {
                            "source": "#main/in_fmt",
                            "id": "#main/ocr-transform-1/in_fmt"
                        },
                        {
                            "source": "#main/out_fmt",
                            "id": "#main/ocr-transform-1/out_fmt"
                        }
                    ],
                    "out": [
                        "#main/ocr-transform-1/out_file"
                    ],
                    "scatter": [
                        "#main/ocr-transform-1/in_file"
                    ],
                    "scatterMethod": "dotproduct",
                    "id": "#main/ocr-transform-1"
                },
                {
                    "run": "#remove-xml-elements.cwl",
                    "in": [
                        {
                            "source": "#main/element",
                            "id": "#main/remove-xml-elements-1/element"
                        },
                        {
                            "source": "#main/ls/out_files",
                            "id": "#main/remove-xml-elements-1/xml_file"
                        }
                    ],
                    "out": [
                        "#main/remove-xml-elements-1/out_file"
                    ],
                    "scatter": [
                        "#main/remove-xml-elements-1/xml_file"
                    ],
                    "scatterMethod": "dotproduct",
                    "id": "#main/remove-xml-elements-1"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "-m",
                "nlppln.commands.ls"
            ],
            "doc": "List files in a directory.\n\nThis command can be used to convert a ``Directory`` into a list of files. This list can be filtered on file name by specifying ``--endswith``.\n",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "--endswith"
                    },
                    "id": "#ls.cwl/endswith"
                },
                {
                    "type": "Directory",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#ls.cwl/in_dir"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "--recursive"
                    },
                    "id": "#ls.cwl/recursive"
                }
            ],
            "stdout": "cwl.output.json",
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "id": "#ls.cwl/out_files"
                }
            ],
            "id": "#ls.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": "ocr-transform",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "ubma/ocr-fileformat"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 3
                    },
                    "id": "#ocr-transform.cwl/in_file"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#ocr-transform.cwl/in_fmt"
                },
                {
                    "type": "string",
                    "inputBinding": {
                        "position": 2
                    },
                    "id": "#ocr-transform.cwl/out_fmt"
                }
            ],
            "stdout": "${\n  var nameroot = inputs.in_file.nameroot;\n  var ext = 'xml';\n  if(inputs.out_fmt == 'text'){\n    ext = 'txt';\n  }\n  return nameroot + '.' + ext;\n}\n",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.in_file.nameroot).*"
                    },
                    "id": "#ocr-transform.cwl/out_file"
                }
            ],
            "id": "#ocr-transform.cwl"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "-m",
                "nlppln.commands.remove_xml_elements"
            ],
            "doc": "Remove specified XML elements from XML file.\n",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string",
                        "inputBinding": {
                            "prefix": "-e"
                        }
                    },
                    "id": "#remove-xml-elements.cwl/element"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#remove-xml-elements.cwl/xml_file"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*.xml"
                    },
                    "id": "#remove-xml-elements.cwl/out_file"
                }
            ],
            "id": "#remove-xml-elements.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
